Hi!

On Jun/18/2020 17:45 (Moscow time) we will host Codeforces Global Round 8.

It is the second round of a 2020 series of Codeforces Global Rounds. The rounds are open and rated for everybody.

The prizes for this round:

- 30 best participants get a t-shirt.
- 20 t-shirts are randomly distributed among those with ranks between 31 and 500, inclusive.

The prizes for the 6-round series in 2020:

- In each round top-100 participants get points according to the table.
- The final result for each participant is equal to the sum of points he gets in the four rounds he placed the highest.
- The best 20 participants over all series get sweatshirts and place certificates.

Thanks to XTX, which in 2020 supported the global rounds initiative!

Problems for this round are set by me. Thanks a lot to the coordinator 300iq and testers thenymphsofdelphi, Lewin, Golovanov399, Osama_Alkhodairy, gamegame, dorijanlendvaj, HenriqueBrito, kocko, ruban, Origenes, Ilya-bar, rahulkhairwar. Their feedback was a huge help and affected the problemset greatly.

The round will have eight problems and will last 150 minutes.

**Scoring distribution: 500 — 1000 — 1500 — 1750 — 2500 — 3000 — 3500 — 3000+1500**

Good luck, and see you on the scoreboard!

**UPD**: the round has concluded, congratulations to the winners:

Check current Codeforces Global series standings here (courtesy of aropan).

You can find the editorial here.

Stay tuned for prizes announcement!

Surprising that even legendary grand masters have coordinators.

Yes

Wow, I don't understand how people like posts :) P.S. Perhaps the situation has changed, but now it looks like this:

Wow, I don't understand how people ignore this.

Be careful — now he knows who downvoted him.

recursion?

recursion?

return 0;

What is the exact job of the coordinator?

To coordinate.

Deleted

It is obvious, with everybody except tester and setters.

He reviews the problems and provides feedback on basis of that. They are highly experienced coders who have impeccable taste of problems.

The submission verdict is actually given by them manually.

i wanna surprise you by saying "even newbies are coordinators" :)

Aiming for T-shirt!

late announcement :p

Combined Round after a long time !

Deliveries in corona times T_TThat's why it is called random distribution.It feels like the main reason why people do CP is to get free T-shirts...

No, sometimes girlfriends too.

wait what?

don't tell us your dream of today

You mean lose a girlfriend?

That means that you had one in the first place...

Can we expect more than 20k participants in this round.

Endagorion... It sounds like a good round

Bad memes*

Will we see a Retired_MiFaFaOvO vs tourist?

There will be fireworks from both the ends.

tourist will back to his throne

Um_nik will beat both

More precisely this will be coding war tourist vs Um_nik vs Retired_MiFaFaOvO ! :)

ecnerwala take it all!

I'm rooting for Benq.

lol looks like a cricket match is gonna happen

No, in this round, @dtc03012 vs @MiFaFaOvO

Hoping to watch a tourist show once again.

Actually its ecnerwala show !

still no sign of MiFaFaOvo :)

He did VP this morning(in China)

Links of previous global rounds:

Codeforces Global Round 1

Codeforces Global Round 2

Codeforces Global Round 3

Codeforces Global Round 4

Codeforces Global Round 5

Codeforces Global Round 6

Codeforces Global Round 7

Hope this helps!

you can use this https://surya1231.github.io/Codeforces-contest/

helpful. Thanks

Thanks..

thanks mate!!

All Global, Div3 and Educational Codeforces Rounds

NICE Round

Hey everyone, those who are turely annoyed with her and want to choose a cool institution please set your institution as of mine. Its a request

I'm annoyed with her, but I don't agree with your opinion too. I don't want to be in any Anti-Fanclub, okay? And also,

don't use your second account to post bad comments.You registered 6 weeks ago and didn't participate in any contests, but your contribution is below -70.Is it like I hate Rachel club ?? Only this time _chandler_ is a part of it instead of Ross xD.

A newbie like me should participate in this? though it is rated for all and the level of questions will be hard

Don't be afraid because you are a newbie. You have to participate in many rounds, and then you would be able to increase both your rating and skills.

Thank you sir for your kind words I'll try my best

Good luck!

Hello guys.I have no idea about calculating contribution.I commented in the last div3 contest announcement then my contribution began to low.Before this i thought contribution is calculated only for blog.Please anyone explain about calculating contribution..Thanks in advance.

Hey bro ,I don't know much about contribution bur make sure that your comment make a positive impact to the community and don't post negative comments. I think it will increase your contribution points. Hope it helps. PS: I earned +2 yesterday

rule but i think skills is more important than your contributions..

Combined Round! Hope it will be fun.

tourist and Retired_MiFaFaOvO both have registered for this round! It will be exciting to see.

Game of thrones... XD

Indeed! GOT without any bloodshed! :p

Don't forget about Um_nik. He will also join the party.

I wish there was a live telecast! :p

Don't worry. Standing will be live :3

:p thanks for this info! :3

An unexpected finale: on a pedestal ascended ecnerwala

7 among top 8 are registered for this contest and left one is coordinator of this round.

With how many problems?

Sorry, didn't notice it was written in the announcment

No offense to anyone

None Taken

current highest ranked post

In 5 contests they would have 1M Youtube subscribers.

would it be rated? EDIT: sry missed it in the announcement.

A codeforces round from Endagorion after a long time. Eagerly waiting...XD

Nice round after a long time..

I hope to see myself as a pupil in today's contest. Good luck for everyone.

scientists or doctors ?

Is the rating calculated differently for these rounds? For example if I get rank 500 in a global round and in a div2 round, would my delta be higher for global round since div1 participants are also considered in official standings? Or will it be the same

of course, sir!

Expecting a very good problemset .

This comment section is shit.

Agreed, the memes turned from actually funny into shit that takes up space.

MikeMirzayanov should actually ban photo comments to prevent this.

Not all images are memes.

What do you expect it to be before the contest started?

Welcome to memeforces!

welcome to

chandlershit postsYour graph reminds me of Mariana Trench.

Oh boi. You're so rude

wow that's so toxic, don't throw shade on him because he's "bad" at CP (as of now)

That is not something Chandler would say

Apologies to Ag12, adityarev, codemastercpp, Jojo_Mojo.

I, unintentionally, crossed the line.

The only way to avoid people posting memes in comment section is to downvote them. So , its a request to all if anyone finds any meme just downvote that(If you found meme funny then laugh and downvote), but you have to downvote,that's the only way because mostly people post memes to increase contributionThose who do not agree do you have any other way?

You got many upvotes (including mine). Because you are Errichto.

Great performance Errichto, I'm glad to see ur level hasn't dropped down even after dedicating so much time to YT.

For the top-100 participants, how is the points calculated? I mean the sequence {$$$1000, 706,575,497,443,403,371 ...$$$} apparently makes no sense. Or does it?

It actually does!! Being a competitive try to find what are the cons of making this sequence in decreasing AP :)

$$$\left \lfloor{\frac{1000}{\sqrt{rank}}-rank+1}\right \rfloor$$$

This function seems pretty interesting, it is ranged between 1000-1 for rank 1-100, also the decay seems fair. Is it the only standard function used for such scoring or there exists more ?

Thanks

If you want fair decay..Why not use...

$$$ points = \lceil{-\frac{ 111 * rank }{ 11 } + \frac{ 11111 }{ 11 }} \rceil$$$

Is it always an integer ? I can't see a clear cut proof.

Ceil function is there.

Because the difference between 1st and 2nd place should be much larger than the difference between the 99th and 100th place.

Yeah, that makes much more sense.

waiting for this contest after global round 7!

and hoping to get t-shirt!!! good luck to all others!!

Waiting for this contest before global round 9!

*_*

Hey, I am somewhat new in Codeforces. I want to ask that ofc my standing will be lower comparable to other Div. 2 rounds, so will it affect my ratings in a negative or positive way?

your rating is based on how you do compared to other participants not your rank. You can read more about it here link.

`Codeforces and Polygon may be temporarily unavailable 2 hours starting from July 18, 05:00 (UTC) due to infrastructure updates.`

I think it should be June 18 ? MikeMirzayanov

They will be upgrading Russian and English versions separately one month apart.

Deleted

Plot twist : round will be hosted in ACM-ICPC style

can someone post previous contest Links by Endagorion.

https://codeforces.com/contests/writer/Endagorion

i hope

"pretest passed"and"accepted"will not follow the rule of social distancingActually this was really fun. Surprised that you got downvotes.

no problem, but for coders coding is real fun

The tourist Is Coming

When score distribution will be announced?

Is there any chance that the contest will be canceled?

No bro, there's not a 1% chance that the contest gets cancelled.

Hope so.

Please check previous comments before commenting something, don't post same repetitive comments and memes in the same blog.

Remember, it's Codeforces, so don't make it memeforces or spamforces :(

Wow! The score distribution for the last problem is almost equal to the score distribution for the first 4 problems!

Good luck everyone!!

Scoring distribution: 500 — 1000 — 1500 — 1750 — 2500 — 3000 — 3500 — 3000+1500. Actually, I am not clear about "3000+1500" part.

May be at that problem there will be a sub-problem also. Like B1, B2 type.

I don't think so, otherwise problem count must have been 9. There might be possibility of subtask1 & subtask2 with partial marking.

B1, B2 count as 1 problem.

MiFaFaOvOvstourist... who will win today ??and I am tourist supporter <3

CODING.

delayed 10 m !

very thanks

More 10 minitues!!

Last five minutes delays are the worst thing ever.

what about cancer?

You sit there like pumped up with adrenaline. And then you have to start all over.

That's why it's delayed 10m

LOL!

Oh boy the queue will troll us again huh?

hope for that's won't be happened .

Glad it didnt troll u

Let's hope that this delay is not a sign of long queues

hopefully queueforces 2.0 doesn't happen

10 min delay?

Seriously why does Codeforces like to delay contests in the last minutes? It's really ruining the momentum and the "zone" :(

So that we can have a short contest of commenting about the delay.

They don't like to delay, there must be some problem. A delay is much better than an unrated round.

It's called ritual.

I almost always barely make it on time because I underestimate how much time is left before a contest starts. Then the delay is announced and I get time to open my IDE.

postponed for 10 mins?

Round delayed for 10 minutes.

The delay is like the apocalypse trompettes before a round.

I got electricity cut and contest is delayed. Hope electricity returns in 10 minutes....

For sure will return! Good luck.

Why you say that.

They were notified of your power outage and delayed it for you.

God's favourite

https://codeforces.com/blog/entry/76348?#comment-609368 Looks like this is the case with you in every contest, XD

Hope queue don't play with us.

No queueforces please :(

Really, is it common to have delays like this?

I hope the round doesn't get cancelled. Fingers crossed XD

If it gets delayed by 10 more mins, I'm gonna have my dinner.

Should have gone for it:(

Wouldn't it be amazing to know what exactly happens when codeforces is working on it's infrastructure? Anyone? Just curious :)

I hope this round will go without any problem and no more delay

Comment section nowadays

Apparently this post is included :(Codeforces waiting for 20k registrations? :P

love to see Radewoosh in top rank

Too Difficult.

The second one is kinda tricky

yea, I'm getting rekt at pretest 3. C was easy tho. Sometimes I don't understand question ordering.

What the hell is this 2nd problem?

Same thing :/ but I figured it out 10 minutes before the end :)

That gap between D and E. Oooooooof.

Solved 4 Problems and left the contest.

Speed-forces for non-red coders. >_<

What a mess I've done? Hope others did well

Nice problems, but it is so demotivating when you just sit 2 hours straight not even coding something...

really.... i think my solution of E is correct... but wrong answer..

For example u have:

Let’s write it in bits:

turn on gravity for let bits fall down and stack at each other, now u have:

Now u just need to sum squares of this numbers

Python code:

Damn, that's crazy visualization. Great work!

When i figured this out, i was like: WHAT? THATS GENIUS

This is the best explanation to a problem I have ever seen.

That's amazing!

I made a video explaining problem D because I really liked the problem — https://www.youtube.com/watch?v=oHgcHjk2fIM

There are many people with these videos, so let me know if it's worth doing more, thanks!

(Well, I liked problem E too, but I didn't solve it)

Understood everything..... Make Video editorials for every Div2.D&E

By any chance, were the rooms decided based on rating? Mine only had me as >= CM and 2 blues rest all cyan or below.

Why limit in E is 4/7, not 4/6? ;.;

If 4/6 this is Problem A/B :P

How?

How do u do it in 4/6?

Iterate from 1 to n. If the current node is not deleted then delete the adjacent nodes of the current node and keep the current node. It will be true because we are always deleting maximum of 2 nodes but keeping 1 node

Let's color the graph in 3 colors such that vertices of the same color don't have edges between them. You can do this from right to left. Then delete 2 smallest sets.

These problems are good. Great round! Took me a long while to find the idea for C. I tried so many things lol. Can anyone share ideas for D?

For D you can just count number of bits that are 1 for every position and then construct from them biggest numbers.

What was the catch in Problem B?Can anybody explain?

2 * 2 * 2 * 2 * 2.... generates longer subsequences than 1*1*1.. *n for a smaller cost, so greedy check 2*2*2*2 and then 3*3*3... (keep on incrementing so 4*4*4... and 5*5*5... etc) until you're ready (you can mix different numbers suchas 2 * 2 *... *3 *3 *3

How to solve E?

Judging from ecnerwala's solution, it is just greedy. And that's where I first realized that

"landing spots on the mountain numbered from 1 to n from the top to the foot of the mountain":facepalm:It's a construction problem with large constraints, of course it's greedy. That doesn't help with finding the correct solution.

KSM problem C

same here spent an hour drawing useless grids :(

What is meant by KSM?

KSM Problem B

First time participated in a "global contest", Wow it was amazing, thanks to the organizers

How to solve D? Whats so easy about D?

My approach which is wrong was to store numbers in min_heap, extract 2 and operate on them, store the greater one back in heap. This worked on so many handwritten cases but not pretest 4 :(

Just count the frequencies of bits, then keep on generating numbers using them till they are not finished greedily!

Oh my god now this looks obviously correct, why I didn't see this :O

I also feel the same way.I was roaming here and there with approaches like set and heaps but after seeing this I feel like how can I miss it:(

Short version — For each operation, you are just swapping the bits in the two numbers. In the end, sum of the count of bits in each position will be the same. Hence just do a column sort (assuming you have a 2D array of numbers represented in binary form)

yeah now I realised this from goyalnikhil064 comment. It seems very easy now! :(

count the number of bit, For Loop(n) , Loop(bit) if count of bit is more than zero, you add the bit value in tmp, and ans += tmp*tmp

try this 2 3 5 ans is 58

Please tell any hack case.

Find it yourself buddy :/

You just need to learn concept of gravity to solve Problem D

How to solve E? someone help please

I solved D in 8 minutes and B in two hours, I was trying to increase subsequences using suffix earlier on, but prefix gave a better answer. Really upset! But a really nice round overall!

Lol, didn't expect C to be a pattern based problem. Just print the coordinates and thats it.

was b something about powers of 2 and 3?

We have 10 factors so I did it by making them as close to each other as possible.

https://www.imageupload.net/image/rQ6xS

Don't know how to upload images. Sorry about that. ^^ This is what I got for case 1 in problem C.

Its wrong because 4 gray box have 3 gray neighbours each

yah its wrong just realized.. how to solve it? help me.

Actually during contest I was making for $$$n=2$$$ and it was not working placing them side by side. So I tried putting them diagonally and it worked. After some time I realised it worked. Refer this I exactly did like this : link

How to solve C

Find a correct answer for the case

`n = 1`

. For the rest, build the staircase.Is it... blade in minecraft??

LOL

This literally reminds me of minecraft lol

You can fill n cells in diagonal order and then make sure that all their neighbouring cells are also grey.And when will you draw this you will find that to make no. of neighbours even you need to fill two cells more diagonally one at top and other at bottom.Hope this helps.

Just look at this

It was basically a problem of constructive algorithm. The major sticking point was to decide which n should have all neighbors grey. I chose them as (1,1), (2,2), (3,3) and so on till (n,n). Now chose all 4 neighbors for them. Some of them might repeat. Also chose 0.0 and (n+1,n+1) because neighbors of first and last point will not have even neighbors

If you take pleasure in blowing 1.5 hours building fancy patterns, you can do it like below (for n = 4).

(After the contest, I saw the other solutions and then smacked myself)

If n is odd.

Thanks

Was that any problem ordering C->D->B. B was really hard.

I'm noob so asking, Is B supposed to be easier than C?

Yes, A<B<C.... in order of increasing difficulty.

deleted

which test is that supposed to be? 2*10^5 * 2^40 fits easily...

Is there such a test?

((2^21)^2)*2*10^5 would fit in long long.

I mistakenly read the constraints as (2^30).My bad

Very very interesting problems, thanks!

Worst contest i have ever seen!..

every time there's this one guy saying: "Worst contest"

I think he is justified because gap between D and E difficulty wise was large

well yes and I too would've liked to get an easier problem E, but at least it was reflected in the scoring distribution — we knew beforehand that E would be hard!

looks like someone under-performed

How to solve B?

let number of first character of "codeforces" n(1), second character n(2) ans so on. Then, just check for the combination of these n(i) with greedy method for which it reaches k at the lowest cost.

Meaning, suppose for k = 4, firstly, the string is "codeforces" which is k = 1 and every n(i) is 1. then, check if it reaches k with 2 first characters, which is "ccodeforces". (combination is 2*1*1*1*1*1*1*1*1*1 = 2) If not, check again with 2 second characters, which is "ccoodeforces". (combination is 2*2*1*1*1*1*1*1*1*1 = 4) which reaches k and is the answer.

Thanks. I don't understand what happens when k is odd, say k = 3. Are you saying that we check for all from 1*1*1*1*1*1*1*1*1*1 to something*something..?

Yes, you can just increment the smallest value of the 10 (if multiple are smallest chose any of them) until they multiply together to be larger than the target.

In theory you can optimise by finding the largest x where x^10 is less than the target and starting from there, but it's not needed.

in the statement, it says at least k in minimum length of string. So, if you try out different cases of odd k, you'll see it is all the same as the even. Because the string length remains the same even if the combination exceeds k. Just write down 2 cases for odd, you'll understand. As for your second confusion, not something*something.. Just go by incrementing number of characters one by one from 1*1*1... (like the example shown in the parent comment) and check if it crosses k.

How to solve F? I think the maximum of $$$R(n)$$$ is $$$\lfloor \frac{n}{2} \rfloor - 1$$$, am I right?

AFAIK, this is incorrect. Try for larger n, like 20.

Do you think believing is worth more than proving? Don't do this in a speed-solving contests...

I kind of see your point, and that wasn't the intent. Apart from E, do you think other problems suffered from this?

Thanks for your comment. I was not particularly suffered from other problems than E because of the believe-vs-proof issue, but the overall experience wasn't good.

I think B, D, and F have a similar kind of issue to some extent. For B and D the proof is rather easy (?) but the "targeted" contestants for them could have felt upset as I have for E.

F is more approachable by experiments (and indeed I did), which is good. But I submitted without proving no better solution exists. Who proved it would have spent non-negligible amount of time, which could lead to a terrible performance for this round.

The ideas for E and F themselves were pretty nice! (at least for Mathematical Olympiads)

Thanks a lot for your feedback! I have a pet peeve for open-ended problems where the initial direction is not immediately clear. Still, too many of such problems is too frustrating, and they tend to get too "mathy". I'll try my best to balance things better next time.

I proved E,F before coding. I don't like hard-proving problem too in rated contests but I think it was not so hard (than coming up with a correct solution) this time.

I think the proof for D is fairly easy and i was able to do it in a fair amount of time,and since i am the "targeted" contestant for it than i think i am the right person to speak for it.Same goes for B, B involves simple high school mathematics to prove.Sorry for my poor English.

Even B and D many solved without proving.

I found the solution for E, but I can't implement in time —

solution for E : === infinite loop === node i = minimum of nodes There is no edge comming to node i.

## (i's leaf) <= 2,

## (i's leaf's leaf) <= 4

open i and i's leaf / close i's leaf's leaf // opened node / (opened + closed node) >= 3/7 : you always satisfies erase-ratio.

## erase the i, i's leaf, i's leaf's leaf in the graph

Am I solved right?

No, there are complications. For example, suppose you have i, i's leaf and i's leaf's leaf. Then say j is another parentless node, and say j's leaf's leaf is one of i's leaf.

I solve problem C with smallest k value... and after end of contest.. k doesn't need to be smallest. T^T

Mind explaining your solution?

Arthur, please do not manage the ski resort anymore.

What so special about 4/7?

i did some cases and it seems that if you greedy for low cases 4/7 should work because you break alternating connections (so if you find a path of length N break 2, 4, 6, etc) but it fails for larger cases like 28 for some reason or another (i drew 28 vertices and kept on mixing and matching but couldn't find the intuition to solve)

If you remove the ends of all the paths of 2 greedily(starting from top to bottom). Then, if x spots are removed, there will y>=x/2 spots that were before these spots in the paths and z>=x/4 which were before the y spots. (x+y+z >= 7/4x => x <=4/7 n)

No one:

Literally no one:

Me: Scribbling problem C in-contest using online minesweeper

As expected from the founder of TLX

In E, does anyone have a counter for this?

$$$S$$$ = {$$$1,2,3,..N$$$}.

while $$$S$$$ isn't empty

Take smallest numbered node $$$v$$$ from $$$S$$$ with indegree 0, add nodes at distance 2 to the answer.

Delete $$$v$$$ and nodes at distance 1, 2 from $$$v$$$ from set $$$S$$$ and update indegrees.

Rather than choosing {6 7 5 10 12 13}, your solution will choose {6 7 8 9 5 10 12 13}.

Wow, thank you very much, during the contest I absolutely did not understand why E does not work :)

Thanks :D

Editorial for C :)

I did the same but from bottom up

There will be odd neighbors in the corner?

Actually no, for corner squares, there will be exactly 2 gray neighbours (1 in vertical and 1 in horizontal).

Another solution (not mine): 84197299

Nice approach. I did same :)

Can you explain?

.

i have no idea how to do E because the only problems i know how to do are greedy LOL

It seems E was greedy :)

seriously? bruhh im kinda sad rip pretest 7

What is this?Wait until System Testing is over.

Least binary searchy interactive problem I've ever seen. Really enjoyed that one.

C and E were really nice too, and I don't have any complaints about the other problems. Great work on the contest overall.

RIP my rating.

My solution for C:

TutorialSolutionovercomplicated

Tell me if you suggest a better approach.

That's another cool approach!

Thanks!

fucking piece of shit.

How to solve D?